/* 
 * $RCSfile: xk_debug.h,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 *
 *
 * $Log: xk_debug.h,v $
 * Revision 1.31.1.5  1997/03/10 21:40:03  mjk
 * *** empty log message ***
 *
 * Revision 1.31.1.4  1994/09/01 04:12:48  menze
 * Subsystem initialization functions can fail
 *
 * Revision 1.31.1.3  1994/07/21  23:26:23  menze
 * Added tracepath
 *
 * Revision 1.31.1.2  1994/04/01  16:44:24  menze
 * Added tracealloc
 *
 * Revision 1.31.1.1  1994/03/21  16:44:28  menze
 * Size of errBuf is now a manifest constant
 *
 * Revision 1.31  1993/12/11  00:23:28  menze
 * fixed #endif comments
 *
 * Revision 1.30  1993/12/11  00:07:02  menze
 * Added traceendpoint and tracemaccommon for Irix
 *
 */

#ifndef xk_debug_h
#define xk_debug_h

#include "platform.h"
#include "x_stdio.h"
#include "trace.h"
#include "xtype.h"

extern int
	tracealloc,
	tracebuserror,
	tracecustom,
        traceendpoint,
  	traceethdrv,
#ifdef XKMACHKERNEL
 	tracelance,
#endif /* XKMACHKERNEL */
 	traceether,
	traceevent,
	tracefixme,
	traceidle,
  	traceidmap,
	traceie,
	traceinit,  
        tracemaccommon,
	tracememoryinit,
	tracemsg,  
	tracenetmask,
	tracepath,
	traceprocesscreation,
	traceprocessswitch,
	traceprotocol,
	traceptbl,
  	traceprottest,
	tracetick,
	tracetrap,
  	tracelock,
  	tracespl,
	tracesessngc,
	traceuser;

#define GLOBAL_ERRBUF_SIZE      250
extern	char errBuf[GLOBAL_ERRBUF_SIZE];


#if ! defined(XK_DEBUG)
#    define NDEBUG
#endif


#ifdef __STDC__

void	xTraceLock( void );
void	xTraceUnlock( void );
void	xTraceInit( void );

#else

void	xTraceLock();
void	xTraceUnlock();
void	xTraceInit();

#endif


#if defined(XK_DEBUG) || defined(lint)

#define PRETRACE(l) { int __i=l; xTraceLock();  while(__i--) putchar(' '); }
#define POSTTRACE { putchar('\n'); xTraceUnlock(); }

#define PRELOG(l)
#define POSTLOG

#ifdef __STDC__
#define XPASTE(X,Y) X##Y
#define PASTE(X,Y) XPASTE(X,Y)


#   define xIfTrace(t, l) \
	if (PASTE(trace,t) >= l)
#   define xTrace0(t, l, f) 		\
	do {				\
	    if (PASTE(trace,t) >= l) {	\
		PRETRACE(l);		\
	    	printf(f); 		\
	    	POSTTRACE;		\
	    }				\
	} while (0)
#   define xTrace1(t, l, f, arg1) 	\
	do {				\
	    if (PASTE(trace,t) >= l) {	\
		PRETRACE(l);		\
	    	printf(f, arg1);	\
	    	POSTTRACE;		\
	    }				\
	} while (0)
#   define xTrace2(t, l, f, arg1, arg2) \
	do {				\
	    if (PASTE(trace,t) >= l) {	\
		PRETRACE(l);		\
	    	printf(f, arg1, arg2);	\
	    	POSTTRACE;		\
	    }				\
	} while (0)
#   define xTrace3(t, l, f, arg1, arg2, arg3) \
	do {				\
	    if (PASTE(trace,t) >= l) {	\
		PRETRACE(l);		\
	    	printf(f, arg1, arg2, arg3);	\
	    	POSTTRACE;		\
	    }				\
	} while (0)
#   define xTrace4(t, l, f, arg1, arg2, arg3, arg4) \
	do {				\
	    if (PASTE(trace,t) >= l) {	\
		PRETRACE(l);		\
	    	printf(f, arg1, arg2, arg3, arg4);	\
	    	POSTTRACE;		\
	    }				\
	} while (0)
#   define xTrace5(t, l, f, arg1, arg2, arg3, arg4, arg5) \
	do {				\
	    if (PASTE(trace,t) >= l) {	\
		PRETRACE(l);		\
	    	printf(f, arg1, arg2, arg3, arg4, arg5); \
	    	POSTTRACE;		\
	    }				\
	} while (0)
#else
#define D___I(X) X


#   define xIfTrace(t, l) \
	if (D___I(trace)t >= l)
#   define xTrace0(t, l, f) 			\
	do {					\
	    if (D___I(trace)t >= l) { 		\
	    	PRETRACE(l); 			\
	    	printf(f); 			\
	    	POSTTRACE; 			\
	    }					\
	} while (0)
#   define xTrace1(t, l, f, arg1) \
	do {					\
	    if (D___I(trace)t >= l) { 		\
	    	PRETRACE(l); 			\
		printf(f, arg1); 		\
	    	POSTTRACE; 			\
	    }					\
	} while (0)
#   define xTrace2(t, l, f, arg1, arg2) \
	do {					\
	    if (D___I(trace)t >= l) { 		\
	    	PRETRACE(l); 			\
	    	printf(f, arg1, arg2); 		\
	    	POSTTRACE; 			\
	    }					\
	} while (0)
#   define xTrace3(t, l, f, arg1, arg2, arg3) \
	do {					\
	    if (D___I(trace)t >= l) { 		\
	    	PRETRACE(l); 			\
	    	printf(f, arg1, arg2, arg3); 	\
	    	POSTTRACE; 			\
	    }					\
	} while (0)
#   define xTrace4(t, l, f, arg1, arg2, arg3, arg4) \
	do {					\
	    if (D___I(trace)t >= l) { 		\
	    	PRETRACE(l); 			\
	    	printf(f, arg1, arg2, arg3, arg4); \
	    	POSTTRACE; 			\
	    }					\
	} while (0)
#   define xTrace5(t, l, f, arg1, arg2, arg3, arg4, arg5) \
	do {					\
	    if (D___I(trace)t >= l) { 		\
	    	PRETRACE(l); 			\
	    	printf(f, arg1, arg2, arg3, arg4, arg5); \
	    	POSTTRACE; 			\
	    }					\
	} while (0)
#endif /* __STDC__ */

	  

#   define xIfTraceP( _obj, _lev ) \
	if ( *(_obj)->traceVar >= (_lev) )

#define xTraceP0( _obj, _lev, _fmt )					\
	do {								\
          xAssert((_obj)->traceVar);					\
	  if ( *(_obj)->traceVar >= (_lev) ) {				\
	    sprintf(errBuf, "[%s]: %s", (_obj)->fullName, (_fmt));	\
    		PRETRACE(_lev);		\
	    	printf(errBuf); 		\
	    	POSTTRACE;		\
	  }								\
 	} while (0)

#define xTraceP1( _obj, _lev, _fmt, _arg1 )				\
	do {								\
          xAssert((_obj)->traceVar);					\
	  if ( *(_obj)->traceVar >= (_lev) ) {				\
	    sprintf(errBuf, "[%s]: %s", (_obj)->fullName, (_fmt));	\
    		PRETRACE(_lev);		\
	    	printf(errBuf, _arg1); 		\
	    	POSTTRACE;		\
	  }								\
	} while (0)

#define xTraceP2( _obj, _lev, _fmt, _arg1, _arg2 )			\
	do {								\
          xAssert((_obj)->traceVar);					\
	  if ( *(_obj)->traceVar >= (_lev) ) {				\
	    sprintf(errBuf, "[%s]: %s", (_obj)->fullName, (_fmt));	\
    		PRETRACE(_lev);						\
	    	printf(errBuf, _arg1, _arg2); 				\
	    	POSTTRACE;						\
	  }								\
	} while (0)

#define xTraceP3( _obj, _lev, _fmt, _arg1, _arg2, _arg3 )		\
	do {								\
          xAssert((_obj)->traceVar);					\
	  if ( *(_obj)->traceVar >= (_lev) ) {				\
	    sprintf(errBuf, "[%s]: %s", (_obj)->fullName, (_fmt));	\
    		PRETRACE(_lev);						\
	    	printf(errBuf, _arg1, _arg2, _arg3);			\
	    	POSTTRACE;						\
	  }								\
	} while (0)

#define xTraceP4( _obj, _lev, _fmt, _arg1, _arg2, _arg3, _arg4 )	\
	do {								\
          xAssert((_obj)->traceVar);					\
	  if ( *(_obj)->traceVar >= (_lev) ) {				\
	    sprintf(errBuf, "[%s]: %s", (_obj)->fullName, (_fmt));	\
    		PRETRACE(_lev);						\
	    	printf(errBuf, _arg1, _arg2, _arg3, _arg4);		\
	    	POSTTRACE;						\
	  }								\
	} while (0)

#define xTraceP5( _obj, _lev, _fmt, _arg1, _arg2, _arg3, _arg4, _arg5 )	\
	do {								\
          xAssert((_obj)->traceVar);					\
	  if ( *(_obj)->traceVar >= (_lev) ) {				\
	    sprintf(errBuf, "[%s]: %s", (_obj)->fullName, (_fmt));	\
    		PRETRACE(_lev);						\
	    	printf(errBuf, _arg1, _arg2, _arg3, _arg4, _arg5);	\
	    	POSTTRACE;						\
	  }								\
	} while (0)


#   define xLog0(t, l, f)	\
	do {			\
	  PRELOG(l);		\
	  printf(f); 		\
	  POSTLOG;		\
	} while (0)
#   define xLog1(t, l, f, arg1)	\
	do {			\
	  PRELOG(l);		\
	  printf(f, arg1); 		\
	  POSTLOG;		\
	} while (0)
#   define xLog2(t, l, f, arg1, arg2)	\
	do {			\
	  PRELOG(l);		\
	  printf(f, arg1, arg2); 		\
	  POSTLOG;		\
	} while (0)
#   define xLog3(t, l, f, arg1, arg2, arg3)	\
	do {			\
	  PRELOG(l);		\
	  printf(f, arg1, arg2, arg3); 		\
	  POSTLOG;		\
	} while (0)
#   define xLog4(t, l, f,arg1, arg2, arg3, arg4)	\
	do {			\
	  PRELOG(l);		\
	  printf(f, arg1, arg2, arg3, arg4); 		\
	  POSTLOG;		\
	} while (0)
#   define xLog5(t, l, f, arg1, arg2, arg3, arg4, arg5)	\
	do {			\
	  PRELOG(l);		\
	  printf(f, arg1, arg2, arg3, arg4, arg5); 		\
	  POSTLOG;		\
	} while (0)
	  

#   define xLogP0(o, l, f)					\
	do {							\
          sprintf(errBuf, "[%s]: %s", (o)->fullName, (f));	\
	  PRELOG(l);						\
    	  printf(errBuf);					\
	  printf(f); 						\
	  POSTLOG;						\
	} while (0)
#   define xLogP1(o, l, f, arg1)				\
	do {							\
          sprintf(errBuf, "[%s]: %s", (o)->fullName, (f));	\
	  PRELOG(l);						\
    	  printf(errBuf, arg1);					\
	  POSTLOG;						\
	} while (0)
#   define xLogP2(o, l, f, arg1, arg2)				\
	do {							\
          sprintf(errBuf, "[%s]: %s", (o)->fullName, (f));	\
	  PRELOG(l);						\
	  printf(errBuf, arg1, arg2); 				\
	  POSTLOG;						\
	} while (0)
#   define xLogP3(o, l, f, arg1, arg2, arg3)			\
	do {							\
          sprintf(errBuf, "[%s]: %s", (o)->fullName, (f));	\
	  PRELOG(l);						\
	  printf(errBuf, arg1, arg2, arg3); 			\
	  POSTLOG;						\
	} while (0)
#   define xLogP4(o, l, f,arg1, arg2, arg3, arg4)		\
	do {							\
          sprintf(errBuf, "[%s]: %s", (o)->fullName, (f));	\
	  PRELOG(l);						\
	  printf(errBuf, arg1, arg2, arg3, arg4); 		\
	  POSTLOG;						\
	} while (0)
#   define xLogP5(o, l, f, arg1, arg2, arg3, arg4, arg5)	\
	do {							\
          sprintf(errBuf, "[%s]: %s", (o)->fullName, (f));	\
	  PRELOG(l);						\
	  printf(errBuf, arg1, arg2, arg3, arg4, arg5); 	\
	  POSTLOG;						\
	} while (0)


#else

#   define xIfTrace(t, l) if (0)
#   define xIfTraceP(t, l) if (0)
#   define xTrace0(t, l, f)
#   define xTrace1(t, l, f, arg1)
#   define xTrace2(t, l, f, arg1, arg2)
#   define xTrace3(t, l, f, arg1, arg2, arg3)
#   define xTrace4(t, l, f, arg1, arg2, arg3, arg4)
#   define xTrace5(t, l, f, arg1, arg2, arg3, arg4, arg5)
#   define xTraceP0(t, l, f)
#   define xTraceP1(t, l, f, arg1)
#   define xTraceP2(t, l, f, arg1, arg2)
#   define xTraceP3(t, l, f, arg1, arg2, arg3)
#   define xTraceP4(t, l, f, arg1, arg2, arg3, arg4)
#   define xTraceP5(t, l, f, arg1, arg2, arg3, arg4, arg5)
#   define xLog0(t, l, f)
#   define xLog1(t, l, f, arg1)
#   define xLog2(t, l, f, arg1, arg2)
#   define xLog3(t, l, f, arg1, arg2, arg3)
#   define xLog4(t, l, f, arg1, arg2, arg3, arg4)
#   define xLog5(t, l, f, arg1, arg2, arg3, arg4, arg5)
#   define xLogP0(o, l, f)
#   define xLogP1(o, l, f, arg1)
#   define xLogP2(o, l, f, arg1, arg2)
#   define xLogP3(o, l, f, arg1, arg2, arg3)
#   define xLogP4(o, l, f, arg1, arg2, arg3, arg4)
#   define xLogP5(o, l, f, arg1, arg2, arg3, arg4, arg5)

#endif	/* XK_DEBUG */

extern void	xError(
#ifdef __STDC__
		       char *
#endif
		       );

#endif	/* xk_debug_h */
