/*
 * $RCSfile: getkerninfo.c,v $
 *
 * Copyright (c) 1992  Arizona Board of Regents
 *
 */
#include <sys/types.h>
#include <sys/socket.h>

struct rtentry;

#include <net/route.h>
#include "xsi_main.h"
#include <ip.h>

static void
IPhost_2_sockaddr(IPhost * iph, struct sockaddr * sa)
{
  sa->sa_family = AF_INET;
  sa->sa_data[0] = iph->a;
  sa->sa_data[1] = iph->b;
  sa->sa_data[2] = iph->c;
  sa->sa_data[3] = iph->d;
}

static void
route_translate(IProuteInfo * src, struct rtentry * dest)
{
  int isahost = (src->mask.d != 0);

  IPhost_2_sockaddr(&src->net, &dest->rt_dst);
  IPhost_2_sockaddr(&src->gw, &dest->rt_gateway);
  dest->rt_flags = RTF_UP | (isahost ? RTF_HOST : 0);
  dest->rt_use = 0;
  dest->rt_ifp = 0;
}

int
getkerninfo(int num, char * buf, int * size, int unknown)
{
    char * rbuf = buf;
    int zero = 0;
    int translate = 0;
    struct rtentry * rtebuf = 0;
    IProuteInfo * iprbuf = 0;
    int i;

    xTrace4(xsi, TR_FUNCTIONAL_TRACE,
         "getkerninfo(num=%d,buf=%x,size=%x,unkn=%d)",
          num, buf, *size, unknown);

    if (!xsi_server) {
	xsi_user_init();
    } /* if */

    switch(num) {
      case KINFO_RT_DUMP:
        if (buf == 0 || size == 0) {
          translate = 1;
          size = &zero;
          buf = &zero;
        } else {
          int iprsize = sizeof(IProuteInfo) * *size / sizeof(struct rtentry);
          iprbuf = (IProuteInfo *)malloc(iprsize);
          rbuf = (char *)iprbuf;
          size = &iprsize;
        }
      break;
    } /* switch */

    XSI(getkerninfo,
               (xsi_server, xsi_cid, num, rbuf, *size, size, unknown, &stat));

    switch(num) {
      /* unfortunate place to put xkernel->BSD data translation */
      case KINFO_RT_DUMP:
        if (translate) {
          i = *size * sizeof(struct rtentry);
          i = i / sizeof(IProuteInfo);
          *size = i;
        } else {
          int j;
          rtebuf = buf;
          i = (*size)/sizeof(IProuteInfo);
          for (j = 0; j < i; j++) {
            route_Xk_2_BSD(&rtebuf[j], &iprbuf[j]);
          }
          free(iprbuf);
          *size = i * sizeof(struct rtentry);
        }
      break;
    } /* switch */
    return *size;
} /* getkerninfo */

			/*** end of getkerninfo.c ***/
