/*     
 * $RCSfile: ipsec-combo_i.h,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1994,1993,1991,1990  Arizona Board of Regents
 *
 */

/* IPSEC header interpreter constants */

#define PART_TYPE_ADDR   0
#define PART_TYPE_SECURE 4

#define SPI_PART  2 
#define USER_PART 3

#define SPI_COUNT 3  /* default max number of embedded spi's */
#define SPI_NET_SIZE 4 /* size in bytes on the wire */
#define IPSEC_NET_NEXT_HDR_SIZE 1
#define IPSEC_NET_HLEN_SIZE 1
#define IPSEC_NET_RESERVED_SIZE 2
#define IPSEC_NET_HDR1 (IPSEC_NET_NEXT_HDR_SIZE + IPSEC_NET_HLEN_SIZE +IPSEC_NET_RESERVED_SIZE)
#define IPSEC_NET_HDR_SIZE (SPI_NET_SIZE+IPSEC_NET_HDR1)

#define IPSEC_MAP_SZ  16
#define IPSEC_MAP2_SZ 64

#define IPSEC_TRANSPORT 0
#define IPSEC_SPI_LU 1

#define MAX_SPIS 10

/* bits to the byte */
#define BYTE_SIZE 8
/* find the IP checksum in the hdr */
#define CK1 10
#define CK2 11
#define IPTIME 8

#define IPSEC_IV_SIZE 8 /* for DES; really should be variable */

/* netsize of part of the transform trailer */
#define ESP_PAYLOAD_TYPE_SZ 1

typedef /* xk_int32*/ unsigned int  esp_nat_spi_t;

typedef struct {
  esp_nat_spi_t  spi;
  char *iv[8];
} esp_short_hdr;
typedef esp_short_hdr ipsec_esp_hdr;

typedef struct ispstate {
  Map mapspi2sessn;
  Map mapspilist2sessn;
  Map mapspi2sa;  /* for outgoing */
  Map mapspi2sa_in; /* for incoming */
  ipsec_esp_hdr   topipsechdr;
  int           iphack;
} ISPState;

typedef struct issstate {
  XObj          km_ds;    /* the spi lookup down session ?? */
  IPpseudoHdr   ippshdr; /* preformed ip hdr */
  IPheader      iphdr; /* preformed ip hdr */
  XObj          hlp, hlpType;
  spi_t        *spi_list;
  IPhost	dst_addr;
  XObj		self;
  int           iphack;
} ISSState;

typedef struct spihost {
  spi_t  spi;
  IPhost host;
} spihost_t;

